<?php
/*
Plugin Name: Peter's Custom Anti-Spam
Plugin URI: http://www.theblog.ca/?p=21
Description: Stop a lot of spambots from polluting your site by making visitors identify a random word displayed as an image before commenting. You can customize the pool of words to display. This is based on Anti-Spam Image by Krazy Nio from http://www.infor96.com/~nio/archives/369
Author: Peter Keung
Version: 0.2
Author URI: http://www.theblog.ca
Change Log:
2006-06-24  The first version.
2006-07-05  Added the option to force registered users to enter the anti-spam word as well
*/
// list your words

$text[1] = "pickwick";
$text[2] = "hockey";
$text[3] = "daniels";
$text[4] = "photo";
$text[5] = "yahoo";
$text[6] = "goober";
$text[7] = "eye";
$text[8] = "galaxy";
$text[9] = "hoop";
$text[10] = "pinto";

// change this to equal 1 if you want to force registered users to enter the anti-spam word as well
$forcereg = 1;

// begin all the code stuff

class AntiSpamImage {
    function AntiSpamImage()
    {
        add_action('comment_form', array(&$this, 'comment_form'));	//add image and input field to comment form
        add_action('comment_post', array(&$this, 'comment_post'));	//add post comment post security code check
    }

    function comment_form()
    {
        global $wpdb, $user_ID, $_SERVER, $forcereg;

        // If the user is logged in, dont prompt for code
        if (isset($user_ID) && $forcereg == 0) {
            return $post_ID;
        }
// pick a random number

$antiselect = rand(1, 10);
        ?>
        <div style="display: left" id="secureimgdiv">
            <p>
            <input type="text" name="securitycode" id="securitycode" size="30" tabindex="4" />
		<input type="hidden" name="matchthis" value="<? echo $antiselect; ?>" />
            <label for="securitycode"><img src="<?php echo $_SERVER['PHP_SELF']; ?>?antiselect=<?php echo $antiselect; ?>" width="125" height="40" alt="Security Image" border="1" /> <small>Anti-spam word (required)</small></label>
            </p>
        </div>

        <script language="JavaScript" type="text/javascript">
            var urlinput = document.getElementById("url");
            var submitp = urlinput.parentNode;
            var substitution2 = document.getElementById("secureimgdiv");
            submitp.appendChild(substitution2, urlinput);
        </script>
        <?php
        return $post_ID;
    }

    function comment_post($post_ID)
    {
        global $wpdb, $user_ID, $_POST, $text, $forcereg;

		$securitycode = strtolower($_POST['securitycode']);
		$matchthis = $text[$_POST['matchthis']];
        // If the user is not logged in check the security code
        if (!isset($user_ID) or $forcereg == 1) {
            if ( '' == $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Error: please enter the anti-spam word.') );
            }
            if ( $matchthis != $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Please enter the correct anti-spam word. Press the back button and try again.') );
            } else {
                unset($matchthis);
            }
        }
        return $post_ID;
    }

    function comment_rollback($post_ID)
    {
        global $wpdb, $wp_version;

        $pid = $wpdb->get_var("SELECT comment_post_ID FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}");
        $wpdb->query("DELETE FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}"); //roll back
        if ($wp_version >= '2.0') {
            $count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->comments} WHERE comment_post_ID = {$pid} AND comment_approved = '1'");
            $wpdb->query( "UPDATE {$wpdb->posts} SET comment_count = {$count} WHERE ID = {$pid}" );
        }
    }
}
// display an image

if (isset($_GET['antiselect'])) {
header("Content-type: image/jpeg");
$antiselect = $_GET['antiselect'];
$antispam = $text[$antiselect];
$image = imagecreate(125,40);
$white = imagecolorallocate($image, 255, 255, 255);
$blue = imagecolorallocate($image, 0, 0, 255);
imagettftext($image, 28, 5, 10, 30, $blue, "jenkinsv", $antispam);
imagejpeg($image);
imagedestroy ($image);
}
else {
new AntiSpamImage();
}
?>